/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Likes Script v2.09 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : ALNJX-209
// URL : http://www.phpkobo.com/ajax_likes.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

// 2016-04-28 : v2.0
(function($){

//-- isArray
if (!Array.isArray) {
	Array.isArray = function(arg) {
		return Object.prototype.toString.call(arg) === '[object Array]';
	};
}

CForm = {

	getJqo : function( form, nm ) {
		var jqo = form.find('input[name="'+nm+'"]');
		if ( jqo.length ) {
			return jqo;
		}
		var jqo = form.find('select[name="'+nm+'"]');
		if ( jqo.length ) {
			return jqo;
		}
		var jqo = form.find('textarea[name="'+nm+'"]');
		if ( jqo.length ) {
			return jqo;
		}

		return null;
	},

	getType : function( form, nm ) {
		var jqo = form.find('input[name="'+nm+'"]');
		if ( jqo.length ) {
			return jqo.attr("type");
		}
		var jqo = form.find('select[name="'+nm+'"]');
		if ( jqo.length ) {
			return "select";
		}
		var jqo = form.find('textarea[name="'+nm+'"]');
		if ( jqo.length ) {
			return "textarea";
		}
	},

	get : function( form, ls ) {
		if ( Array.isArray(ls) ) {
			var px = {};
			for( var i=0; i<ls.length; i++ ) {
				var nm = ls[i];
				px[nm] = this._get( form, nm );
			}
		} else {
			var px = this._get( form, ls );
		}

		return px;
	},

	_get : function( form, nm ) {

		var type = this.getType(form,nm);

		var v = '';
		switch( type ) {

		default:
			v = form
				.find('input[name="'+nm+'"]')
				.val();
			break;

		case "radio":
			v = form
				.find('input:radio[name="'+nm+'"]:checked')
				.val();
			break;

		case "checkbox":
			var jqo = form.find('input:checkbox[name="'+nm+'"]');
			if ( jqo.length == 1 ) {
				v = jqo.is(':checked') ? 1 : 0;
			} else {
				var rx = [];
				jqo.each(function(){
					if ( $(this).is(':checked') ) {
						rx.push($(this).val());
					}
				});
				v = rx.join(',');
			}
			break;

		case "select":
			v = form
				.find('select[name="'+nm+'"] option:selected')
				.val();
			break;

		case "textarea":
			v = form
				.find('textarea[name="'+nm+'"]')
				.val();
			break;
		}

		return v;
	},

	set : function( form, nv, val ) {
		if ( val == undefined ) {
			for( var nm in nv ) {
				this._set(form,nm,nv[nm]);
			}
		} else {
			this._set(form,nv,val);
		}
	},

	_set : function( form, nm, val ) {

		var type = this.getType(form,nm);

		switch( type ) {

		default:
			form
				.find('input[name="'+nm+'"]')
				.val(val);
			break;

		case "radio":
			form
				.find('input:radio[name="'+nm+'"][value="' + val + '"]')
				.attr('checked', 'checked');
			break;

		case "checkbox":
			var jqo = form.find('input:checkbox[name="'+nm+'"]');
			if ( jqo.length == 1 ) {
				jqo.prop('checked',val);
			} else {
				var rx = val.split(",");
				jqo.each(function(){
					var b = $.inArray($(this).val(),rx) == -1 ? 0 : 1;
					$(this).prop('checked',b);
				});
			}
			break;

		case "select":
			form
				.find('select[name="'+nm+'"]')
				.val(val);
			break;

		case "textarea":
			form
				.find('textarea[name="'+nm+'"]')
				.val(val);
			break;

		}
	},

	setup : function( form, nv ) {
		for( var nm in nv ) {
			this._setup(form,nm,nv[nm]);
		}
	},

	_setup : function( form, nm, val ) {

		var type = this.getType(form,nm);

		switch( type ) {

		case "select":
			// {options:...,selected:...}
			var select = form.find('select[name="'+nm+'"]');
			select.html("");
			var sel = ( "selected" in val ) ? val.selected : '';
			$.each(val.options, function(key, value) {
				var data = {value:key,text:value};
				if ( key == sel ) {
					data.selected = "selected";
				}
				select.append($("<option/>", data));
			});
			break;

		}
	},

	indicateErrorState : function( jqo_form, error_fields ) {
		jqo_form
			.find("input,select,textarea")
			.parents(".form-group")
			.removeClass("has-error");
		if ( error_fields != null ) {
			for ( var i in error_fields ) {
				var f = error_fields[i];
				jqo_form.find(
					"input[name='"+f+"'],"+
					"select[name='"+f+"'],"+
					"textarea[name='"+f+"']")
				.parents(".form-group")
				.addClass("has-error");
			}
		}
	},

	printErrorAlerts : function( jqo_form, error_alerts ) {
		var jqo = jqo_form.find(".error-alerts");
		jqo.html("");
		if ( error_alerts != null ) {
			for ( var i in error_alerts ) {
				var s = '<div class="alert alert-danger" role="alert">' +
					'<span class="glyphicon glyphicon-exclamation-sign"></span>' +
					'&nbsp;' + error_alerts[i] + '</div>';
				jqo.append(s);
			}
		}
	}

};

window.CForm = CForm;

}(jQuery));
