<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Likes Script v2.09 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : ALNJX-209
// URL : http://www.phpkobo.com/ajax_likes.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CBend_poll extends CBend {

	const TBL_NAME = "poll";
	const ID_NAME = "poll_id";

	public function init() {
		$this->bind("hd_search");
		$this->bind("hd_edit_inp");
		$this->bind("hd_edit_done");
		$this->bind("hd_del_multi");
		$this->bind("hd_codegen");
	}

	public function hd_search( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- config
		$cfg_key = "{$tbl}/search";
		CDTable::init( $cfg_key );

		//-- locale
		$lca_key = "{$tbl}/search";
		$lca = CEnv::locale( $lca_key );

		//-- search criteria
		$criteria = $_REQUEST["criteria"];
		$pkey = $criteria["keyword"];

		//-- open database
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- select clause
		$clx[] = CSql::clSelect(array(
			self::ID_NAME,
			"pkey",
			"caption",
			"cy",
			"cn",
			));

		$clx[] = CSql::clFrom(self::TBL_NAME);

		//-- where clause
		$cond = array();

		if ( $pkey != "" ) {
			$cond2 = array();
			$cond2[] = CSql::clCond("pkey","L%%",$pkey);
			$cond2[] = CSql::clCond("caption","L%%",$pkey);
			$cond[] = implode(" OR ",$cond2);
		}

		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- start caching
		self::obStart();

		//-- search result
		$result = CDTable::process( $clx );
		include( dirname(__FILE__) . "/tpl.dtable.inc.php" );
		CDb::freeResult($result);

		//-- end caching
		$html = self::obEnd();

		//-- resp
		$data->resp['result'] = 'OK';
		$data->resp['html'] = $html;
		$data->resp['dts'] = CDTable::getDts();
	}

	protected function validate( &$form, &$vx, &$error_alerts, &$error_fields ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- init
		$vx = array();
		$error_alerts = array();
		$error_fields = array();

		//-- locale
		$lca_key = "{$tbl}/validate";
		$lca = CEnv::locale( $lca_key );

		//-- pkey
		if ( trim($form["pkey"]) == "" ) {
			$error_alerts[] = $lca["err:empty-pkey"];
			$error_fields[] = "pkey";
		} else {
			$vx["pkey"] = $form["pkey"];
		}

		//-- caption
		$vx["caption"] = !empty($form["caption"]) ? $form["caption"] : null;

		//-- cy
		if ( trim($form["cy"]) == "" ) {
			$error_alerts[] = $lca["err:empty-cy"];
			$error_fields[] = "cy";
		} else {
			$b = false;
			if ( ctype_digit($form["cy"]) ) {
				$cy = intval($form["cy"]);
				$b = ( $cy >= 0 );
			}
			if ( $b ) {
				$vx["cy"] = $cy;
			} else {
				$error_alerts[] = $lca["err:invalid-cy"];
				$error_fields[] = "cy";
			}
		}

		//-- cn
		if ( trim($form["cn"]) == "" ) {
			$error_alerts[] = $lca["err:empty-cn"];
			$error_fields[] = "cn";
		} else {
			$b = false;
			if ( ctype_digit($form["cn"]) ) {
				$cn = intval($form["cn"]);
				$b = ( $cn >= 0 );
			}
			if ( $b ) {
				$vx["cn"] = $cn;
			} else {
				$error_alerts[] = $lca["err:invalid-cn"];
				$error_fields[] = "cn";
			}
		}

		return ( count($error_alerts) == 0 );
	}

	public function hd_edit_inp( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- locale
		$lca_key = "{$tbl}/input";
		$lca = CEnv::locale( $lca_key );

		//-- search criteria
		$id = $_REQUEST["id"];

		//-- open database
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- select clause
		$clx[] = CSql::clSelect(array(
			self::ID_NAME,
			"pkey",
			"caption",
			"cy",
			"cn",
		));

		$clx[] = CSql::clFrom(self::TBL_NAME);

		//-- where clause
		$cond = array();
		$cond[] = CSql::clCond(self::ID_NAME,"=",$id);

		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- run query
		$result = CSql::query($clx);
		if ( CDb::getRowCount( $result ) == 0 ) {
			$lca = CEnv::locale("{$tbl}/validate");
			$data->resp['result'] = 'OK';
			$data->resp['err'] = $lca["err:not-exist"];
			return;
		}

		$rs = CDb::getRowA( $result );

		//-- start caching
		self::obStart();

		//-- template
		include( dirname(__FILE__) . "/tpl.edit.inc.php" );
		CDb::freeResult($result);

		//-- end caching
		$html = self::obEnd();

		//-- resp
		$data->resp['result'] = 'OK';
		$data->resp['html'] = $html;
	}

	public function hd_edit_done( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- form data
		$form = $_REQUEST["form"];
		$id = $_REQUEST["id"];

		//-- validate
		if ( !$this->validate( $form, $vx, $error_alerts, $error_fields ) ) {
			$data->resp['result'] = 'OK';
			$data->resp['error_alerts'] = $error_alerts;
			$data->resp['error_fields'] = $error_fields;
			return;
		}

		//-- open database
		//CModule::connect("db");
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- update clause
		$clx[] = CSql::clUpdate(self::TBL_NAME,$vx);

		//-- where clause
		$cond = array();

		$cond[] = CSql::clCond(self::ID_NAME,"=",$id);

		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- run query
		CSql::query($clx);
		$this->hd_search( $data );

		//-- resp
		$data->resp['result'] = 'OK';
	}

	public function hd_del_multi( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- selrec
		$selrec_param = ( isset($_REQUEST["selrec"]) ) ?
			$_REQUEST["selrec"] : array();

		$selrec = array();
		foreach( $selrec_param as $id ) {
			$selrec[] = intval($id);
		}

		$lca = CEnv::locale("{$tbl}/del-multi");

		if ( count($selrec) == 0 ) {
			$result = $lca["err:select-at-least-one"];
		} else {

			//-- open database
			CDb::open();

			//-- delete user data
			//CDelete::userdata( $selrec );

			//-- build clauses
			$clx = array();

			//-- delete clause
			$clx[] = CSql::clDelete(self::TBL_NAME);

			//-- where clause
			$cond = array();
			foreach( $selrec as $id ) {
				$cond[] = CSql::clCond(self::ID_NAME,"=",$id);
			}
			$clx[] = CSql::clWhere("OR",$cond);

			//-- sql
			CSql::query($clx);

			//-- do search
			self::hd_search( $data );

			//-- reuslt
			$result = "OK";
		}

		//-- resp
		$data->resp['result'] = $result;
	}

	public function hd_codegen( $data ) {
		$id = $_REQUEST["id"];
		$url = CApp::vurl("codegen","id=" . $id);
		$data->resp['result'] = "@redirect@:" . $url;
	}

}

?>