<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Likes Script v2.09 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : ALNJX-209
// URL : http://www.phpkobo.com/ajax_likes.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CBend_user extends CBend {

	const TBL_NAME = "user";
	const ID_NAME = "user_id";

	public function init() {
		$this->bind("hd_search");
		$this->bind("hd_reg_inp");
		$this->bind("hd_reg_done");
		$this->bind("hd_edit_inp");
		$this->bind("hd_edit_done");
		$this->bind("hd_del_multi");
	}

	protected function printStatus( $status ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- locale
		$lca = CEnv::locale( "{$tbl}/search" );

		$key = "";
		switch ( $status ) {
		case 0:
			$key = "ban-circle";
			$title = $lca[ "alt:inactive" ];
			break;
		case 1:
			$key = "ok-sign";
			$title = $lca[ "alt:active" ];
			break;
		}
		echo '<span class="glyphicon glyphicon-' .
			$key . '" title="' . $title . '" style="font-size:130%;"></span>';
	}

	public function hd_search( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- config
		$cfg_key = "{$tbl}/search";
		CDTable::init( $cfg_key );

		//-- locale
		$lca_key = "{$tbl}/search";
		$lca = CEnv::locale( $lca_key );

		//-- search criteria
		$criteria = $_REQUEST["criteria"];
		$status = $criteria["status"];
		$keyword = $criteria["keyword"];

		//-- open database
		//CModule::connect("db");
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- select clause
		$clx[] = CSql::clSelect(array(
			self::ID_NAME,
			"status",
			"b_admin",
			"username",
			));

		$clx[] = CSql::clFrom(self::TBL_NAME);

		//-- where clause
		$cond = array();

		if ( $status != "" ) {
			$cond[] = CSql::clCond("status","=",$status);
		}

		if ( $keyword != "" ) {
			$cond[] = "(`username` LIKE '%" . CDb::sani($keyword). "%')";
		}

		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- start caching
		self::obStart();

		//-- search result
		$result = CDTable::process( $clx );
		include( dirname(__FILE__) . "/tpl.dtable.inc.php" );
		CDb::freeResult($result);

		//-- end caching
		$html = self::obEnd();

		//-- resp
		$data->resp['result'] = 'OK';
		$data->resp['html'] = $html;
		$data->resp['dts'] = CDTable::getDts();
	}

	public function hd_reg_inp( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- locale
		$lca_key = "{$tbl}/input";
		$lca = CEnv::locale( $lca_key );

		//-- start caching
		self::obStart();

		//-- template
		include( dirname(__FILE__) . "/tpl.reg.inc.php" );

		//-- end caching
		$html = self::obEnd();

		//-- resp
		$data->resp['result'] = 'OK';
		$data->resp['html'] = $html;
	}

	private function usernameExists( $id, &$form, &$error_alerts, &$error_fields ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- init
		$error_alerts = array();
		$error_fields = array();

		//-- open database
		CDb::open();

		$cond = array();
		$cond[] = CSql::clCond("username","=",$form["username"]);

		if ( $id ) {
			$cond[] = CSql::clCond("user_id","!=",$id);
		}

		$rsx = CTable::selectRec( self::TBL_NAME, array(self::ID_NAME), $cond );

		//-- record exists?
		if ( count($rsx) ) {
			$lca = CEnv::locale( "user/validate" );
			$error_alerts[] = $lca["err:username-exists"];
			$error_fields[] = "username";
			return true;
		}

		return false;
	}

	protected function validate( &$form, &$vx, &$error_alerts, &$error_fields ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- init
		$vx = array();
		$error_alerts = array();
		$error_fields = array();

		//-- locale
		$lca_key = "{$tbl}/validate";
		$lca = CEnv::locale( $lca_key );

		//-- status
		$status = $form["status"];
		if (( $status == 0 ) || ( $status == 1 )) {
			$vx["status"] = $status;
		} else {
			$error_alerts[] = $lca["err:empty-status"];
			$error_fields[] = "status";
		}

		//-- b_admin
		$b_admin = $form["b_admin"];
		if (( $b_admin == 0 ) || ( $b_admin == 1 )) {
			$vx["b_admin"] = $b_admin;
		}

		//-- username
		if ( empty($form["username"]) ) {
			$error_alerts[] = $lca["err:empty-username"];
			$error_fields[] = "username";
		}
		$vx["username"] = $form["username"];

		//-- b_password
		if ( $form["b_password"] ) {

			//-- password
			if ( empty($form["password"]) ) {
				$error_alerts[] = $lca["err:empty-password"];
				$error_fields[] = "password";
			}

			//-- password_conf
			if ( empty($form["password_conf"]) ) {
				$error_alerts[] = $lca["err:empty-password_conf"];
				$error_fields[] = "password_conf";
			}

			//-- password & password_conf
			if ( $form["password"] != $form["password_conf"] ) {
				$error_alerts[] = $lca["err:cannot-confirm"];
				$error_fields[] = "password";
				$error_fields[] = "password_conf";
			}

			$vx["password"] = $form["password"];
		}

		return ( count($error_alerts) == 0 );
	}

	public function hd_reg_done( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- form data
		$form = $_REQUEST["form"];
		$form["b_password"] = 1;

		//-- validate
		if ( !$this->validate( $form, $vx, $error_alerts, $error_fields ) ) {
			$data->resp['result'] = 'OK';
			$data->resp['error_alerts'] = $error_alerts;
			$data->resp['error_fields'] = $error_fields;
			return;
		}

		//-- prevent username duplication
		if ( $this->usernameExists( 0, $form, $error_alerts, $error_fields ) ) {
			$data->resp['result'] = 'OK';
			$data->resp['error_alerts'] = $error_alerts;
			$data->resp['error_fields'] = $error_fields;
			return;
		}

		$vx["create_dt"] = date("Y-m-d H:i:s");

		//-- open database
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- insert clause
		$clx[] = CSql::clInsert(self::TBL_NAME,$vx);

		//-- run query
		CSql::query($clx);
		$this->hd_search( $data );

		//-- resp
		$data->resp['result'] = 'OK';
	}

	public function hd_edit_inp( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- locale
		$lca_key = "{$tbl}/input";
		$lca = CEnv::locale( $lca_key );

		//-- search criteria
		$id = $_REQUEST["id"];

		//-- open database
		//CModule::connect("db");
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- select clause
		$clx[] = CSql::clSelect(array(
			self::ID_NAME,
			"status",
			"b_admin",
			"username",
			));

		$clx[] = CSql::clFrom(self::TBL_NAME);

		//-- where clause
		$cond = array();
		$cond[] = CSql::clCond(self::ID_NAME,"=",$id);

		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- run query
		$result = CSql::query($clx);
		if ( CDb::getRowCount( $result ) == 0 ) {
			$lca = CEnv::locale("{$tbl}/validate");
			$data->resp['result'] = 'OK';
			$data->resp['err'] = $lca["err:not-exist"];
			return;
		}

		$rs = CDb::getRowA( $result );

		//-- start caching
		self::obStart();

		//-- template
		include( dirname(__FILE__) . "/tpl.edit.inc.php" );
		CDb::freeResult($result);

		//-- end caching
		$html = self::obEnd();

		//-- resp
		$data->resp['result'] = 'OK';
		$data->resp['html'] = $html;
	}

	public function hd_edit_done( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- form data
		$form = $_REQUEST["form"];
		$id = $_REQUEST["id"];

		//-- validate
		if ( !$this->validate( $form, $vx, $error_alerts, $error_fields ) ) {
			$data->resp['result'] = 'OK';
			$data->resp['error_alerts'] = $error_alerts;
			$data->resp['error_fields'] = $error_fields;
			return;
		}

		//-- prevent username duplication
		if ( $this->usernameExists( $id, $form, $error_alerts, $error_fields ) ) {
			$data->resp['result'] = 'OK';
			$data->resp['error_alerts'] = $error_alerts;
			$data->resp['error_fields'] = $error_fields;
			return;
		}

		//-- open database
		//CModule::connect("db");
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- update clause
		$clx[] = CSql::clUpdate(self::TBL_NAME,$vx);

		//-- where clause
		$cond = array();

		$cond[] = CSql::clCond(self::ID_NAME,"=",$id);

		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- run query
		CSql::query($clx);
		$this->hd_search( $data );

		//-- resp
		$data->resp['result'] = 'OK';
	}

	public function hd_del_multi( $data ) {

		//-- table name
		$tbl = self::TBL_NAME;

		//-- selrec
		$selrec_param = ( isset($_REQUEST["selrec"]) ) ?
			$_REQUEST["selrec"] : array();

		$selrec = array();
		foreach( $selrec_param as $id ) {
			$selrec[] = intval($id);
		}

		$lca = CEnv::locale("{$tbl}/del-multi");
		$cfg = CEnv::config("{$tbl}/root-admin");

		if ( count($selrec) == 0 ) {
			$result = $lca["err:select-at-least-one"];
		} else {
			if ( in_array( $cfg["root-admin-id"], $selrec ) ) {
				$result = $lca["err:can-not-delete-root"];
			} else {

				//-- open database
				CDb::open();

				//-- delete user data
				//CDelete::userdata( $selrec );

				//-- build clauses
				$clx = array();

				//-- delete clause
				$clx[] = CSql::clDelete(self::TBL_NAME);

				//-- where clause
				$cond = array();
				foreach( $selrec as $id ) {
					$cond[] = CSql::clCond(self::ID_NAME,"=",$id);
				}
				$clx[] = CSql::clWhere("OR",$cond);

				//-- sql
				CSql::query($clx);

				//-- do search
				self::hd_search( $data );

				//-- reuslt
				$result = "OK";
			}

		}

		//-- resp
		$data->resp['result'] = $result;
	}

}

?>