<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Likes Script v2.09 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : ALNJX-209
// URL : http://www.phpkobo.com/ajax_likes.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CVoter {
	private static $cfg;

	public static function setup() {
		self::$cfg = CEnv::config("client/voter");
	}

	public static function isIPCheckOn() {
		return self::$cfg["check-ip"];
	}

	public static function isCookieCheckOn() {
		return self::$cfg["check-cookie"];
	}

	public static function getIP() {
		$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : "";
		if ( !filter_var($ip, FILTER_VALIDATE_IP) ) {
			$ip = "";
		}
		return $ip;
	}

	public static function getCookieVal( $iid ) {
		$cookie_key = self::getCookieKey( $iid );
		if ( !isset($_COOKIE[$cookie_key]) ) {
			return null;
		}
		return $_COOKIE[$cookie_key];
	}

	private static function createRandomString( $n ) {
		$s = '';
		for ( $i = 0; $i < $n; $i++ ) {
			if ( rand( 1, 2 ) == 1 ) {
				$s .= chr(rand(97, 122));
			} else {
				$s .= chr(rand(65, 90));
			}
		}
		return $s;
	}

	private static function getMaxCookieExpTime() {
		if ( PHP_INT_SIZE == 4 ) {// 32 bits PHP
			//-- 2147483647 = 2^31-1 = 2038-01-18 19:14:07
			return 2147483647;
		} else {// 64 bits PHP
			//-- 10 years
			return time() + (10 * 365 * 24 * 60 * 60);
		}
	}

	private static function getCookieKey( $iid ) {
		return "ld-" . str_replace("=","",base64_encode($iid));
	}

	public static function createCookieVal() {
		return self::createRandomString(15);
	}

	public static function setCookie( $iid, $cookie_val ) {
		$cookie_key = self::getCookieKey( $iid );
		$t = self::getMaxCookieExpTime();
		setcookie( $cookie_key, $cookie_val, $t );
		$_COOKIE[$cookie_key] = $cookie_val;
	}

	public static function removeCookie( $iid ) {
		$cookie_key = self::getCookieKey( $iid );
		unset($_COOKIE[$cookie_key]);
		setcookie($cookie_key, null, -1 );
	}

	public static function isCheckOn( $vtype ) {
		switch( $vtype ) {
		case "ip":
			if ( !self::isIPCheckOn() ) {
				return false;
			}
			break;
		case "ck":
			if ( !self::isCookieCheckOn() ) {
				return false;
			}
			break;
		}
		return true;
	}

	public static function findVoter( $poll_id, $vtype, $vkey, &$ans ) {
		if ( !self::isCheckOn( $vtype ) ) { return null; }

		$voter_id = null;
		$ans = null;

		if ( $vkey == null ) {
			return null;
		}

		//-- build clauses
		$clx = array();

		//-- select clause
		$clx[] = CSql::clSelect(array("voter_id","ans"));

		//-- from
		$clx[] = CSql::clFrom("voter");

		//-- where clause
		$cond = array();
		$cond[] = CSql::clCond("poll_id","=",$poll_id);
		$cond[] = CSql::clCond("vtype","=",$vtype);
		$cond[] = CSql::clCond("vkey","=",$vkey);
		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- limit
		$clx[] = "LIMIT 1";

		//-- run query
		$result = CSql::query($clx);
		if ( $rs = CDb::getRowA( $result ) ) {
			$voter_id = $rs["voter_id"];
			$ans = $rs["ans"];
		}

		//-- free result
		CDb::freeResult( $result );

		//-- return
		return $voter_id;
	}

}

?>