/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Ajax Likes Script v2.09 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : ALNJX-209
// URL : http://www.phpkobo.com/ajax_likes.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

function initAjaxLikesApp( $, settings ) {

// To remove the following error message in Chrome:
// "event.layerX and event.layerY are broken and deprecated"
// "in WebKit. They will be removed from the engine in "
// "the near future."
if ( $.event.props.indexOf ) {
	$.event.props.splice($.event.props.indexOf("layerY"),1);
	$.event.props.splice($.event.props.indexOf("layerX"),1);
}

CFormatter = {

	number_format : function( n ) {
		return n.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
	},

	nf : function( n ) {
		if ( n < 10.0 ) {
			var d = 1;
			var n = Math.floor(n*10)/10;
		} else {
			var d = 0;
			var n = Math.floor(n);
		}
		var s = this.number_format( n );
		s = s.replace( /\.0/, '' );
		return s;
	},

	shortenNumber : function( n ) {
		var K = 1 * 1000;
		var M = K * 1000;
		var G = M * 1000;
		if ( n >= G ) {
			return this.nf( n/G ) + "G";
		} else if ( n >= M ) {
			return this.nf( n/M ) + "M";
		} else if ( n >= K ) {
			return this.nf( n/K ) + "K";
		} else {
			return n;
		}
	},

	ffCount : function( cnt, cfmin ) {
		if (( cnt >= cfmin ) && ( cfmin >= 0 )) {
			return this.shortenNumber( cnt );
		} else {
			return this.number_format( cnt );
		}
	},

	ffPercent : function( per, pdig ) {
		return parseFloat(Math.round(per * 100) / 100).toFixed(pdig);
	}
};

function CAjaxLikes( jqo_cont ) {
	this.jqo_cont = jqo_cont;
	this.iid = this.getAttr("data-iid",jqo_cont);
	this.shorten = this.getAttr("data-shorten",jqo_cont);
	this.pdig = this.getAttr("data-pdig",jqo_cont);
	this.checkmark = this.getAttr("data-checkmark",jqo_cont);
	this.setup();

	var resp = {
		items:{
			"cy":this.getAttr("data-cy",jqo_cont),
			"cn":this.getAttr("data-cn",jqo_cont)
		},
		"choice":this.getAttr("data-choice",jqo_cont)
	};
	this.update(resp);
}

CAjaxLikes.prototype = {

	getAttr : function( attr_name, jqo ) {
		if (
			( typeof( jqo.attr( attr_name ) ) == 'undefined' ) || 
			( jqo.attr( attr_name ) == '' ) // for Opera
		) {
			return null;
		}
		var s = jqo.attr( attr_name );

		//-- unencode "&quot;" entities
		s = s.replace(new RegExp("&quot;", 'g'), "&");

		return s;
	},

	send : function( data, func ) {
		var _this = this;
		$.ajax({
			url:settings.url_server,
			data:data,
			dataType: 'json',
			success:function(resp) {
				_this.process( resp, func );
			},
			error:function( jqXHR, textStatus, errorThrown ) {
				var s = '[$.ajax.error]\n';
				s += jqXHR.responseText+'\n';
				s += textStatus+'\n';
				s += errorThrown;
				console.log(s);
			}
		});
	},

	onError : function( resp ) {
		var err_prefix = "@ERR:";
		if ( resp.result.substr(0,err_prefix.length) == err_prefix ) {
			alert(resp.result);
		} else {
			console.log(resp.result);
		}
	},

	process : function( resp, func ) {
		if ( resp.result == 'OK' ) {
			func.call( this, resp );
		} else {
			this.onError( resp );
		}
	},

	setup : function() {
		var _this = this;

		this.jqo_cont.find( '.ld-btn-y' ).click( function(e) {
			e.preventDefault();
			_this.vote( 'y' );
		});

		this.jqo_cont.find( '.ld-btn-n' ).click( function(e) {
			e.preventDefault();
			_this.vote( 'n' );
		});
	},

	vote : function( v ) {
//console.log("["+this.iid+"]");
		this.send( { cmd:'vote', iid:this.iid, ans:v }, function( resp ){
			this.update(resp);
		});
	},

	update : function( resp ) {
		this.updateStats(resp);
		this.updateChecked(resp);
	},

	updateStats : function( resp ) {
		var cnt_y = parseInt(resp.items['cy']);
		var cnt_n = parseInt(resp.items['cn']);
		var cnt_total = cnt_y + cnt_n;

		var per_y;
		var per_n;
		if ( cnt_total ) {
			per_y = ( cnt_y * 100 ) / cnt_total;
			per_n = ( cnt_n * 100 ) / cnt_total;
		} else {
			per_y = 0;
			per_n = 0;
		}

		var bar = this.jqo_cont.find( '.ld-bar' );
		if ( bar.length ) {
			var w_bar = bar.width();

			var w_y;
			var w_n;
			if ( cnt_total == 0 ) {
				w_y = 0;
				w_n = 0;
			} else if ( cnt_n == 0 ) {
				w_y = w_bar;
				w_n = 0;
			} else if ( cnt_y == 0 ) {
				w_y = 0;
				w_n = w_bar;
			} else {
				w_y = Math.round( w_bar * cnt_y / cnt_total );
				w_n = w_bar - w_y;
			}
			bar.find( '.ld-bar-y' ).width( w_y );
			bar.find( '.ld-bar-n' ).width( w_n );
		}

		var s_cnt_y = CFormatter.ffCount(cnt_y,this.shorten);
		var s_cnt_n = CFormatter.ffCount(cnt_n,this.shorten);

		this.jqo_cont.find( '.ld-cnt-y' ).html( s_cnt_y );
		var jqo_s_y = this.jqo_cont.find( '.ld-s-y' );
		if ( cnt_y != 1 ) {
			jqo_s_y.show();
		} else {
			jqo_s_y.hide();
		}
		this.jqo_cont.find( '.ld-cnt-n' ).html( s_cnt_n );
		var jqo_s_n = this.jqo_cont.find( '.ld-s-n' );
		if ( cnt_n != 1 ) {
			jqo_s_n.show();
		} else {
			jqo_s_n.hide();
		}

		var s_per_y = CFormatter.ffPercent(per_y,this.pdig);
		var s_per_n = CFormatter.ffPercent(per_n,this.pdig);
		this.jqo_cont.find( '.ld-per-y' ).html( s_per_y );
		this.jqo_cont.find( '.ld-per-n' ).html( s_per_n );
	},

	updateChecked : function( resp ) {
		if ( this.checkmark != 't' ) { return; }

		var jqo_ck_y = this.jqo_cont.find( '.ld-ck-y' );
		var jqo_ck_n = this.jqo_cont.find( '.ld-ck-n' );

		jqo_ck_y.css({
			visibility:"hidden"
		});
		jqo_ck_n.css({
			visibility:"hidden"
		});

		if ( resp.choice == 'y' ) {
			jqo_ck_y.css({
				visibility:"visible"
			});
		}
		if ( resp.choice == 'n' ) {
			jqo_ck_n.css({
				visibility:"visible"
			});
		}
	}

}

CAjaxLikesApp = {

	instance_data_sig : "ajax-likes",
	prefix_container : '.ld-container-async',

	isIE7 : function() {
		return (navigator.appVersion.indexOf("MSIE 7.")!=-1);
	},

	escapeDq : function( str ){
		return str.replace(new RegExp('"', 'g'), '\\"' );
	},

	splitToHtmlAndCss : function(icode) {
		var ax = icode.split("</style>");
		return {
			css : ax[0] + "</style>",
			html : ax[1]
		};
	},

	initApp : function() {
		//console.log("CAjaxLikesApp.init");
	},

	initInstance : function() {
		var _this = this;
		$( '.ld-container' ).each( function(){
			if ( $(this).data(_this.instance_data_sig) === undefined ) {
				var obj = new CAjaxLikes( $(this) ); 
				$(this).data(_this.instance_data_sig,obj);
			}
		});
	},

	initLateInst : function( rec ) {
		var _this = this;
		$(document).ready(function(){
			if ( rec.icode != null ) {//--async
				var rx = _this.splitToHtmlAndCss(rec.icode);// for IE7&8

				if ( !_this.isIE7() ) {
					$(_this.prefix_container+'[data-iid="'+_this.escapeDq(rec.iid)+'"]').html(rx.html);
				} else {
					$(_this.prefix_container).each(function(){
						if ( $(this).attr("data-iid") == rec.iid ) {
							$(this).html(rx.html);
						}
					});
				}

				$('head').append(rx.css);
			}
			_this.initInstance();
		});
	}

};

CAjaxLikesApp.initApp();

return CAjaxLikesApp;

};
